(ns com.aurellem.gb.text-speed
  (:use (com.aurellem.gb gb-driver util characters))
  (:import [com.aurellem.gb.gb_driver SaveState]))

(def text-speed-address 0xD354)

(def text-speed->code
  {:slow 69
   :mid 67
   :fast 65
   :ultra 64
   })

(def code->text-speed
  (zipmap (vals text-speed->code)
          (keys text-speed->code)))
  
(defn read-text-speed
  ([^SaveState state]
     (code->text-speed (aget (memory state)
                             text-speed-address)))
  ([] (read-text-speed @current-state)))

(defn set-text-speed
  ([^SaveState state new-speed]
     (set-memory 
      state 
      text-speed-address
      (text-speed->code new-speed new-speed)))
  ([new-speed] (set-text-speed @current-state new-speed)))